# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is "Java-Python Extension (JPE)".
# 
# The Initial Developer of the Original Code is Frederic Bruno Giacometti.
# Portions created by Frederic Bruno Giacometti are
# Copyright (C) 2000-2001 Frederic Bruno Giacometti. All Rights Reserved.
# 
# Contributor(s): frederic.giacometti@arakne.com
#
# Acknowledgments:
# Particular gratitude is expressed to the following parties for their
# contributing support to the development of JPE:
#     - Arakne SARL (France) and its staff (http://www.arakne.com);
#       and in particular to Jean Hemmi, Marie-Therese Plaze and Didier Rano
#     - The European Union through its funding of the IST Alice project
#     - Dean Vucinic from Vrije Universiteit Brussel (Belgium),
#       coordinator of the IST Alice project
#     - iPhrase Technologies Inc. (Massachusetts, USA)
#

# 
# The contents of this file are subject to the Mozilla Public
# License Version 1.1 (the "License"); you may not use this file
# except in compliance with the License. You may obtain a copy of
# the License at http://www.mozilla.org/MPL/
# 
# Software distributed under the License is distributed on an "AS
# IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
# implied. See the License for the specific language governing
# rights and limitations under the License.
# 
# The Original Code is "Java-Python Extension (JPE)".
# 
# The Initial Developer of the Original Code is Frederic Bruno Giacometti.
# Portions created by Frederic Bruno Giacometti are
# Copyright (C) 2000 Frederic Bruno Giacometti. All Rights Reserved.
# 
# Contributor(s): frederic.giacometti@arakne.com
#
# Acknowledgments:
# Particular gratitude is expressed to the following parties for their
# support to the initial development phases of JPE:
#     - Arakne SARL and its staff (http://www.arakne.com);
#       and in particular to Jean Hemmi, Marie-Therese Plaze and Didier Rano.
#     - The European Union through its funding of the IST Alice project.
#     - Dean Vucinic from Vrije Universiteit Brussel (VUB)

import unittest, sys

import java
from java import javalib

_initialized = 0

class TestCaseJavaVM( unittest.TestCase):
    def test001jclass( self):
        cls = javalib.jclass( 'java/lang/String')
##    def tearDown( self):
##        self.javavm.destroy()
    def utest002jclass( self):
        clscls = javalib.jclass( 'java/lang/Class')
        strs = clscls.methodsToStrings()
        print len( strs), "java/lang/Class methodsToStrings:"
        for str in strs:
            print '\t' + str
    def utest003jclass( self):
        clscls = javalib.jclass( 'java/lang/Class')
        meths = clscls.methodsDesc()
        print len( meths), "java/lang/Class methodsDesc:"
        for meth in meths:
            print '\t' + `meth`
    def utest004jclass( self):
        clscls = javalib.jclass( 'java/lang/Class')
        methods = clscls.getMethods()
        print len( methods), 'java.lang.Class methods()'
        print methods
        for mth in methods:
            print '\t' + `mth.methodDesc()`
    def test005jclass( self):
        clsint = javalib.jclassForName( 'java.lang.Void')
        print str( clsint)
    def test006jclass( self):
        from java import getJclass, Jstring
        if __debug__: print '111'
        System = getJclass( 'java.lang.System')
        if __debug__: print '222'
        out = System.out
        if __debug__: print '333'
        out.println( Jstring( 'Hello world'))
        if __debug__: print '444'
        getJclass( 'java.lang.System').out.println( Jstring( 'Hello world II'))
    def test007( self):
        from java import getJclass
        props = getJclass( 'java.lang.System').getProperties()
        penum = props.propertyNames()
        while penum.hasMoreElements():
            if __debug__ and 1 < sys.version_info[ 0]:
                import gc
                print 'pppp', gc.isenabled()
            pmeth = penum.nextElement
            if 0 and __debug__: print 'ppp1'
            pname = pmeth()
            #pname = penum.nextElement() # crash here
            if 0 and __debug__: print 'qqqq'
            prpmth = props.getProperty
            if 0 and __debug__: print 'qqq1'
            val = prpmth( pname)
            if 0 and __debug__: print 'qqq2'
            print '%s=%s' % (pname, val) # or here
            if 0 and __debug__: print 'rrrr'
        print 'xxxx'
        
suite = unittest.makeSuite( TestCaseJavaVM)

##if __name__ == '__main__':
##    if 1 < sys.version_info[ 0]:
##        import gc # python 2.0 stuff
##        gc.disable()
##    gc.set_debug( gc.DEBUG_STATS)
    
##    def setUp():
##        if not _initialized:
##            global _initialized
##            import os
##            self.javavm = java.JavaVM(
##                os.environ[ 'JRE_LIBJVM'],
##                [ '-Xcheck:jni',
##                  '-verbose:jni,gc', #class
##                  '-Djava.library.path=.',
##                  '-Djava.class.path=' + os.environ[ 'CLASSPATH'],
##                  ])
##            _initialized = 1
##    setUp()
##    unittest.TextTestRunner().run( suite)
