// Copyright (c) Arakne 2000, All Rights Reserved
// www.arakne.com

// This program is an unpublished work fully protected
// by the international copyright laws and considered
// a trade secret belonging to the copyright holder

package python;

/** protected class - implements native calls */

class Javapy
{
  static
  {
    System.loadLibrary( "Javapy");
    jpe_init( "Javapy library rlock object",
	      Thread.currentThread().getThreadGroup());
  }

  private Javapy() {;}

  static private native void jpe_init( Object rlock,
				       ThreadGroup threadGroup);

  static protected native boolean Py_IsInitialized();
  static protected native long Py_Initialize();
  static protected native void Py_Finalize();
  static protected native long interpFromThread( long pyThread);
  /** not implemented */
  static protected native long Py_NewInterpreter();
  /** not implemented */
  static protected native void Py_EndInterpreter( long tstate);
  /** not implemented */
  static protected native void Py_SetProgramName( String name);
  /** not implemented */
  static protected native String Py_GetProgramName();
  /** not implemented */
  static protected native String Py_GetPrefix();
  /** not implemented */
  static protected native String Py_GetExecPrefix();
  /** not implemented */
  static protected native String Py_GetProgramFullPath();
  /** not implemented */
  static protected native String Py_GetPath();
  /** not implemented */
  static protected native String Py_GetVersion();
  /** not implemented */
  static protected native String Py_GetPlatform();
  /** not implemented */
  static protected native void PyEval_AcquireLock();
  /** not implemented */
  static protected native void PyEval_ReleaseLock();
  static synchronized protected native long threadStateNew( long
							    vrootThread);
  static synchronized protected native
      void threadStateDelete( long vthreadState);
  static protected native String format_exception( long threadState,
						long lexcType,
						long lexc,
						long ltraceback);
  static protected native void PyEval_AcquireThread( long tstate);
  static protected native void PyEval_RestoreThread( long tstate);
  static protected native void PyEval_ReleaseThread( long tstate);
  static protected native long PyEval_SaveThread();
  /** not implemented */
  static protected native long PyInterpreterState_New();
  /** not implemented */
  static protected native void PyInterpreterState_Clear( long interp);
  /** not implemented */
  static protected native void PyInterpreterState_Delete( long interp);
  /** not implemented */
  static protected native long PyThreadState_New( long interp);
  /** not implemented */
  static protected native void PyThreadState_Clear( long tstate);
  /** not implemented */
  static protected native void PyThreadState_Delete( long tstate);
  /** not implemented */
  static protected native long PyThreadState_Get();
  /** not implemented */
  static protected native long PyThreadState_Swap( long tstate);
  static synchronized protected native
      void attach( long tstate, boolean owned);

  // PyObject

  static protected native long getNone( long threadState);
  static protected native long jobject_new( long threadState, Object self);

  // memory API
  static protected native void Py_DECREF( long threadState, long pself);
  static protected native void Py_INCREF( long threadState, long pself);

  // PyModule
  /** not implemented */
  static protected native boolean PyModule_Check( long threadState,
						    long pself);
  /** not implemented */
  static protected native long PyModule_GetDict( long threadState,
						 long pself);
  /** not implemented */
  static protected native String PyModule_GetName( long threadState,
						   long pself);
  /** not implemented */
  static protected native String PyModule_GetFileName( long threadState,
						       long pself);
  static protected native long PyImport_ImportModule( long threadState,
						      String name);
  /** not implemented */
  static protected native long PyImport_ImportModuleEx( long threadState,
							String name,
							long globals,
							long locals,
							long fromList);
  /** not implemented */
  static protected native long PyImport_Import( long threadState,
						long name);
  /** not implemented */
  static protected native long PyImport_GetModuleDict( long threadState);

  // PyString module
  /** not implemented */
  static protected native long PyString_Type( long threadState);
  /** not implemented */
  static protected native boolean PyString_Check( long threadState,
					       long pself);
  static protected native long PyString_FromString( long threadState,
						 String str);
  /** not implemented */
  static protected native long PyString_Size( long threadState,
					   long pself);
  /** not implemented */
  static protected native String PyString_AsString( long threadState,
						 long pself);
  /** not implemented */
  static protected native void PyString_Concat( long threadState,
					     long pself, long pstr);
  /** not implemented */
  static protected native long PyString_Format( long threadState,
					     long pself, long ptuple);
  /** not implemented */
  static protected native void PyString_InternInPlace( long threadState,
						    long pself);
  /** not implemented */
  static protected native long PyString_InternFromString( long threadState,
						       String str);

  /** not implemented */
  static native protected long PyUnicode_FromUTF16( long threadState,
						    String val);
  
  // misc.
  static protected native Object ptr2object( long pself);
  /** not implemented */
  static protected native long PyObject_Type( long threadState, long pself);
  // object protocol API
  static protected native int PyObject_Compare( long threadState, long pself,
						long other);
  static protected native int PyObject_Hash( long threadState, long pself);
  static protected native String PyObject_Repr( long threadState, long pself);
  static protected native String PyObject_Str( long threadState, long pself);
  static protected native Object PyJobject_AsJobject( long threadState,
						      long pself);
  /** not implemented */
  static protected native boolean PyObject_HasAttrString( long threadState,
							  long pself,
							  String attr);
  static protected native long PyObject_GetAttrString( long threadState,
						    long pself, String name);
  static protected native void PyObject_SetAttrString( long threadState,
						       long pself,
						       String name, long pobj);
  /** not implemented */
  static protected native void PyObject_DelAttrString( long threadState,
						       long pself,
						       String attr);
  /** not implemented */
  static protected native boolean PyCallable_Check( long threadState,
						    long pself);
  /** not implemented */
  static protected native long PyObject_CallObject( long threadState,
						 long pself, long ptuple);
  static protected native long PyObject_CallArray( long threadState,
						long pself,
						python.PyObject[] args);
  /** not implemented */
  static protected native boolean PyObject_IsTrue( long threadState,
						   long pself);
  /** not implemented */
  static protected native long PyObject_Length( long threadState, long pself);
  /** not implemented */
  static protected native long PyObject_GetItem( long threadState, long pself,
						 long pkey);
  /** not implemented */
  static protected native long PyObject_SetItem( long threadState, long pself,
						 long pkey, long val);
  /** not implemented */
  static protected native void PyObject_DelItem( long threadState, long pself,
						 long pkey);
  // PyType

  static protected native long PyType_Type( long threadState);
  /** not implemented */
  static protected native boolean PyType_Check( long threadState,
						long pself);

  // PyInstance

  static protected native long PyInstance_Type( long threadState);
  /** not implemented */
  static protected native boolean PyInstance_Check( long threadState,
						    long pself);

  // PySequence

  /** not implemented */
  static native protected boolean PySequence_Check( long threadState,
						    long pself);
  /** not implemented */
  static native protected long PySequence_Length( long threadState,
						  long pself);
  /** not implemented */
  static native protected void PySequence_Append( long threadState,
						long pself, long pitem);
  /** not implemented */
  static native protected long PySequence_Concat( long threadState,
						  long pself, long other);
  /** not implemented */
  static native protected long PySequence_Repeat( long threadState,
						  long pself, int count);
  /** not implemented */
  static native protected long PySequence_GetItem( long threadState,
						   long pself, long idx);
  /** not implemented */
  static native protected long PySequence_GetSlice( long threadState,
						    long pself,
						    long start, long end);
  /** not implemented */
  static native protected void PySequence_SetItem( long threadState,
						   long pself, long i,
						   long val);
  /** not implemented */
  static native protected void PySequence_DelItem( long threadState,
						   long pself, long i);
  /** not implemented */
  static native protected void PySequence_SetSlice( long threadState,
						    long pself,
						    long start, long end,
						    long val);
  /** not implemented */
  static native protected void PySequence_DelSlice( long threadState,
						    long pself,
						    long start, long end);
  /** not implemented */
  static native protected long PySequence_Tuple( long threadState,
						 long pself);
  /** not implemented */
  static native protected long PySequence_Count( long threadState,
					    long pself, long val);
  /** not implemented */
  static native protected boolean PySequence_Contains( long threadState,
						       long pself, long val);
  /** not implemented */
  static native protected long PySequence_Index( long threadState,
						 long pself, long val);

  // PyList

  static protected native long PyList_Type( long threadState);
  /** not implemented */
  static protected native boolean PyList_Check( long threadState,
						long pself);
  /** not implemented */
  static protected native long PyList_New( long threadState, int len);
  /** not implemented */
  static protected native int PyList_Size( long threadState, long pself);
  /** not implemented */
  static protected native long PyList_GetItem( long threadState,
					    long pself, int index);
  /** not implemented */
  static protected native void PyList_SetItem( long threadState, long pself,
					    int index, long item);
  /** not implemented */
  static protected native void PyList_Insert( long threadState, long pself,
					   int index, long item);
  /** not implemented */
  static protected native void PyList_Append( long threadState,
					   long pself, long item);
  /** not implemented */
  static protected native long PyList_GetSlice( long threadState,
					     long pself, int low, int high);
  /** not implemented */
  static protected native long PyList_SetSlice( long threadState, long pself,
					     int low, int high,
					     long itemlist);
  /** not implemented */
  static protected native void PyList_Sort( long threadState, long pself);
  /** not implemented */
  static protected native void PyList_Reverse( long threadState,
					    long pself);
  /** not implemented */
  static protected native long PyList_AsTuple( long threadState,
					    long pself);

  // PyMapping

  static protected native boolean PyMapping_Check( long threadState,
						long pself);
  /** not implemented */
  static protected native long PyMapping_Length( long threadState,
					      long pself);
  /** not implemented */
  static protected native void PyMapping_DelItemString( long threadState,
						     long pself,
						     String key);
  /** not implemented */
  static protected native void PyMapping_DelItem( long threadState,
					       long pself,
					       long key);
  /** not implemented */
  static protected native boolean PyMapping_HasKeyString( long threadState,
						       long pself,
						       String key);
  /** not implemented */
  static protected native boolean PyMapping_HasKey( long threadState,
						 long pself,
						 long key);
  /** not implemented */
  static protected native long PyMapping_Keys( long threadState, long pself);
  /** not implemented */
  static protected native long PyMapping_Values( long threadState,
						 long pself);
  /** not implemented */
  static protected native long PyMapping_Items( long threadState,
						long pself);
  /** not implemented */
  static protected native long PyMapping_GetItemString( long threadState,
						     long pself,
						     String key);
  static protected native long PyMapping_GetItem( long threadState,
					       long pself,
					       long key);
  /** not implemented */
  static protected native long PyMapping_SetItemString( long threadState,
						     long pself,
						     String key, long v);
  /** not implemented */
  static protected native long PyMapping_SetItem( long threadState,
					       long pself,
					       long key, long v);

  // PyDict

  static protected native long PyDict_New( long threadState);

  //PyTuple

  /** not implemented */
  static protected native long PyTuple_Type( long threadState);
  /** not implemented */
  static protected native boolean PyTuple_Check( long threadState,
						 long pself);
  /** not implemented */
  static protected native long PyTuple_New( long threadState,
					 long pself, int len);
  /** not implemented */
  static protected native int PyTuple_Size( long threadState, long pself);
  /** not implemented */
  static protected native long PyTuple_GetItem( long threadState,
					     long pself, int index);
  /** not implemented */
  static protected native long PyTuple_GetSlice( long threadState,
						 long pself, int low,
						 int high);
  /** not implemented */
  static protected native void PyTuple_SetItem( long threadState,
						long pself,
						int index, long item);
  /** not implemented */
  static native protected long PyTuple_FromPyArray( long threadState,
						    PyObject[] array);
  /** not implemented */
  static native protected long PyTuple_FromArray( long threadState,
						  Object[] array);

  // PyNumber

  /** not implemented */
  static protected native long PyInt_FromInt( long threadState, int val);
  /** not implemented */
  static protected native long PyInt_FromLong( long threadState, long val);
  /** not implemented */
  static protected native long PyFloat_FromFloat( long threadState,
						  float val);
  /** not implemented */
  static protected native long PyFloat_FromDouble( long threadState,
						double val);
}
